//////////////////////////////////////////////////
///          		Message                   ///
/////////////////////////////////////////////////


//class Diapo{
function Diapo(options){
	/*
	Attributs : 
	id : l'id de containerDOM, l'élément du DOM qui contiendra le message défilant. 
	paragraphes : pile de messages à faire défiler successivement
	
	//Eléments du DOM : si ils ne sont pas présents comme noeuds fils de containerDOM, les éléments boxDOM et containerDOM sont créés
	
	boxDOM : div du DOM qui contient le message défilant (Sortie affichée)
	containerDOM : élément du DOM considéré comme le cadre d'affichage principal (Sortie affichée).
	*/
	this.setDiapo=function(options){
		this.stop();
		options=UTIL.options2json(options);
		if(UTIL.isEmpty(options)){options="";}
		if(typeof options=='string'){
			this.diapoXML=document.createElement("div");
			this.diapoXML.className="Diapo";
			this.diapoXML.innerHTML=options;
			options={};
		}
		else if('diapoXML' in options){
			this.diapoXML=options.diapoXML;
		}
		else if('diapo' in options){
			this.diapoXML=options.diapo;
		}
		else if('XML' in options){
			this.diapoXML=options.XML;
		}
		else{
			throw("Pas d'élément 'message' permettant d'instancier la Diapo");
		}
		UTIL.setOptions(this, options, Diapo.CONST.options_defaut);
		
		// UTIL.copyDiv(this.diapoXML, this.containerDOM);
		// console.log(this.containerDOM);
		this.initialisation();
	}
	
	this.initDOM=function(){
		var that=this;
		this.rootDOM = UTIL.findOrCreate('#theatre');
		this.containerDOM=this.diapoXML.cloneNode(true);
		this.containerDOM.className='Diapo';
		this.diapoXML.removeAttribute("id");
		this.rootDOM.appendChild(this.containerDOM);
	}
	

	
	this.initialisation=function(){
		var that=this;
		if(this.containerDOM){
			this.containerDOM.style.display='none';
		}
		this.stop();
		this.fini=false;
	}
	
	this.afficher=function(){
		this.containerDOM.style.display="block";
		this.containerDOM.className="Diapo";
	}
	
	this.cacher=function(){
		var that=this;
		switch(this.transition){
			case 'fade':
				this.containerDOM.className="Diapo fadeOut";
				this.to=setTimeout(function(){that.fini=true;},1000);
			break;
			case 'wait':
				this.to=setTimeout(function(){that.containerDOM.style.display="none";that.fini=true;},1000);
			break;
			case 'stay':
				this.fini=true;
				//reste là figé
			break;
			default:
				this.containerDOM.style.display='none';
			break;
		}
	}
	
	this.start=function(){
		if(!this.pause){return;}
		var that=this;
		this.afficher();
		this.to=setTimeout(function(){that.fin();},3000);
	}
	
	this.stop=function(){
		this.pause=true;
	}
	
	this.fin=function(){
		this.stop();
		this.cacher();
		this.fini=true;
	}
	
	// constructor(options){
	UTIL.setOptions(this, Diapo.CONST.options_defaut);
	this.setDiapo(options);
	this.initDOM();
	this.initialisation();
	// }
	
}
Diapo.CONST={
	options_defaut:{
		container : null,
		pause:true,
		fini:false,
		transition:"fade"
	}
}