//////////////////////////////////////////////////
///          		Message                   ///
/////////////////////////////////////////////////

// class Message{
Message=function(options){
	/*
	Attributs : 
	id : l'id de containerDOM, l'élément du DOM qui contiendra le message défilant. 
	paragraphes : pile de messages à faire défiler successivement
	
	//Eléments du DOM : si ils ne sont pas présents comme noeuds fils de containerDOM, les éléments boxDOM et containerDOM sont créés
	
	boxDOM : div du DOM qui contient le message défilant (Sortie affichée)
	containerDOM : élément du DOM considéré comme le cadre d'affichage principal (Sortie affichée).
	*/
	
	this.setMessage=function(options){
		this.stop();
		options=UTIL.options2json(options);
		if(UTIL.isEmpty(options)){options="";}
		if(typeof options=='string'){
			this.XML=document.createElement("message");
			this.XML.className="mess_type_str";
			this.XML.innerHTML=options;
			options={};
		}
		else if('message' in options){
			this.XML=options.message;
		}
		else if('XML' in options){
			this.XML=PROC.processXML(options.XML, true);
		}
		else{
			throw("Pas d'élément 'message' ou 'XML' permettant d'instancier le Message");
		}
		
		UTIL.setOptions(this, options, Message.CONST.options_defaut);
		
		//découpage en paragraphes :
		var pXML=this.XML.querySelector("p");
		if(!pXML){
			this.paragrapheXML=this.XML;
		}
		else{
			this.paragrapheXML=null;
			this.nextParagraphe();
		}
		this.initialisation();
	}
	
	this.initDOM=function(){
		var that=this;
		
		this.rootDOM = UTIL.findOrCreate('#theatre');
		
		this.boxDOM=document.createElement("div");
		this.boxDOM.className='message_box';
		this.boxDOM.style.display='none';
		this.boxDOM.onclick=function(){return;};
		this.rootDOM.appendChild(this.boxDOM);
		
		this.containerDOM=document.createElement("p");
		this.containerDOM.className='container';
		this.boxDOM.appendChild(this.containerDOM);
	}
	
	this.initialisation=function(){
		var that=this;
		this.boxDOM.style.display='none';
		this.stop();
		this.fini=false;
		this.defile=Message.CONST.options_defaut.defile;
		this.duree_transition=Message.CONST.options_defaut.duree_transition;
		if(this.defile){this.to=-1;}
		if(PROC){PROC.setObjet(this.name, this);}
	}
	
	this.nextParagraphe=function(){
		var that=this;
		this.paragrapheXML=PROC.next(this.paragrapheXML, this.XML);		
		if(!this.paragrapheXML){
			this.fin();
			return;
		}
		switch(this.paragrapheXML.tagName.toLowerCase()){
			case 'p':
				// 
			break;
			case 'ul':
				//par défaut, on revient à la racine du dialogue
				if(!this.paragrapheXML.getAttribute('type')){this.paragrapheXML.setAttribute('type', 'stay');}
			break;
			default:
				this.nextParagraphe();
			break;
		}
		
		return this.paragrapheXML;
	}
		
	
	
	this.afficher_message=function(){
		var that=this;
		UTIL.empty(this.containerDOM);
		this.boxDOM.style.display='block';//visible
		
		
		if(!this.paragrapheXML){
			return this.fin();
		}
		
		that.boxDOM.onclick=function(e){return false;}
		if(this.paragrapheXML.tagName.toLowerCase()=='p'){//trouver un truc plus simple...
			this.txt=this.paragrapheXML.innerHTML.trim();
			this.boxDOM.className='message_box';
			if(this.defile){
				this.defiler();
				that.boxDOM.onclick=function(e){return Message.JS_Fonc.click_mode_defiler(that,e)};
			}
			else{
				that.boxDOM.onclick=function(){return that.decaler(that);}
				this.decaler();
			}
		}
		else if(this.paragrapheXML.tagName.toLowerCase()=='ul'){
			this.boxDOM.className='dialogue_box';
			this.boxDOM.onclick=function(e){return;};
			this.afficher_choix();
		}
		else{
			// console.log("nest paragraphe INVALIDE");
		}
	}
	
	this.relance_defiler=function(){
		var that=this;
		if(this.to==-1){
			this.to=setInterval(function(){that.defiler();}, this.dt);
			var icone=this.boxDOM.querySelector('.arrow_decale');
			if(icone){
				icone.parentElement.removeChild(icone);
			}
		}
		else{
			// console.log("c'est bloqué :" + this.to);
		}
	}
	
	this.stop_defiler=function(){
		this.pause=true;
		clearInterval(this.to);
		this.boxDOM.onclick=function(e){return;};//pas de click durant la duree_transition
		this.to=-1;
		this.txt='';
		this.n=0;
	}
	
	this.defiler=function(){
		var that=this;
		// if(this.pause){return;}
		this.relance_defiler();
		// var now=Date.now();
		// var elapsed=last_time ? Date.now() - last_time : this.dt;
		
		if(!this.n){this.n=0;}
		//si il reste du texte à faire défiler :
		if(this.txt.length > this.n){
			var car = this.txt[this.n];
			if(car == '<'){
				
				var res=this.txt.substring(this.n).match(Message.CONST.re.balise);
				if(res){var balise=res[0].substring(1, res[0].length-1);}
				else{
					throw('Erreur balise"' + '" dans Message');						
				}
				this.n+=res[0].length-1;
				this.parseAction(balise);
			}
			this.containerDOM.innerHTML=this.txt.substring(0,this.n+1);//écriture this.n-ième caractère
			if(this.containerDOM.scrollHeight > this.containerDOM.offsetHeight){//scrolling
				this.containerDOM.scrollTop = this.containerDOM.scrollHeight;
			}
			//relance pour le caractère suivant
			this.n++;
		}
		else{//si tout le texte a défilé :
			this.stop_defiler();
			if(this.duree_transition>0){
				setTimeout(function(){that.pause=false;that.transition();},that.duree_transition);				
			}
			else{
				Message.JS_Fonc.click_mode(that);
			}
		}
	}
	
	this.decaler=function(that){//pour résoudre la portée du this dans onclick... :/
		if(!that){that=this;}
		var H=that.containerDOM.scrollHeight - that.containerDOM.offsetHeight;
		//initialisation du message
		if(this.containerDOM.innerHTML==''){
			this.containerDOM.innerHTML=this.txt;//paragrapheXML.innerHTML.trim();// !
			this.containerDOM.scrollTop=0;
		}
		//décalage du message
		else if(that.containerDOM.scrollTop < H){//Si il reste du texte à décaler
			that.containerDOM.scrollTop += that.containerDOM.offsetHeight;
			if(that.containerDOM.scrollTop == H){
				that.boxDOM.removeChild(that.boxDOM.querySelector('.arrow_decale'));						
			}
		}
		//dernier click : sortie du message
		else{
			that.transition();
		}
	}
	
	this.afficher_choix=function(){
		var that=this;
		this.defile=false;
		UTIL.empty(this.containerDOM);
		var ulDOM=document.createElement('ul');
		this.containerDOM.appendChild(ulDOM);
		UTIL.copyAttr(this.paragrapheXML, ulDOM, ['id']);
		if(this.paragrapheXML.getAttribute('type')=='stay'){
			this.paragrapheXML.setAttribute('repeat','true');
		}
		
		var liXML=PROC.next(null, this.paragrapheXML);
		var nliXML=0;
		while(liXML && liXML!=this.paragrapheXML){
			if(liXML.tagName.toLowerCase()=='li'){
				nliXML++;
				//on marque les dialogues profonds
				if(liXML.querySelector('ul')){liXML.setAttribute('important', 'true');}
				var liDOM=document.createElement('li');
				ulDOM.appendChild(liDOM);
				UTIL.copyAttr(liXML,liDOM, ['id']);
				if(liXML.getAttribute('visited')=='true'){
					liDOM.setAttribute('visited','true');
				}
				//titre choix :
				var titreXML=PROC.next(null, liXML, 'title');
				if(titreXML){
					var titre=titreXML.innerHTML;
				}
				else{
					var titre=liXML.getAttribute('title');
					if(!titre){
						titre=!liXML.firstElementChild ? liXML.innerHTML : '';
					}
					//besoin d'une div comme curseur avant le contenu pour appeler nextParagraphe à partir de celui-ci					
					titreXML=document.createElement('title');
					titreXML.innerHTML=titre;
					UTIL.prependChild(liXML, titreXML);
				}
				liDOM.innerHTML=titre;//liXML.innerHTML;//ppour l'instant
				liDOM.onclick=function(arg){return function(){Message.JS_Fonc.click_choix(that, arg)}}(liXML);
			}
			liXML=PROC.next(liXML, this.paragrapheXML);
		}
		//réponses épuisées :
		if(nliXML==0){
			this.paragrapheXML.removeAttribute("stay");
			this.transition();
		}
	}
	
	this.transition=function(){
		this.nextParagraphe();
		this.afficher_message();
	}
	
	this.start=function(){
		if(!this.pause){return;}
		if(this.paragrapheXML){
			this.pause=false;
			this.afficher_message();
		}
	}
	
	this.stop=function(){
		this.pause=true;
		if(this.to>0){
			// clearTimeout(this.to);
			// this.to=-1
		}
		
	}
	
	this.fin=function(){
		this.stop();
		this.paragrapheXML=null;
		UTIL.empty(this.containerDOM);
		this.boxDOM.style.display='none';
		this.boxDOM.onclick=function(){return;};
		this.fini=true;
	}
	
	this.parseAction=function(txt){
		if(txt[0]=='/'){return;}
		if(!/^[a-z0-9 ='"]+$/.test(txt)){throw("Mauvaises instructions balisées dans le Message : " + txt);}
		txt=txt.trim().replace(/  +/,' ');
		txt=txt.trim().replace(/  ?= ?/,'=');
		var t=txt.split(' ');
		if(Array.isArray(t) && t.length > 0){
			var action = t[0];
			var args={};
			for(var i=1;i<t.length;i++){
				var arg=t[i].split('=');
				var key=arg[0];
				var val=arg.length>1 ? arg[1] : "";
				args[key]=val.replace(/['"]/,'');;
			}
			//ailleurs ?
			this.executeAction(action,args);
		}
		return txt;
	}
	
	this.executeAction=function(action, args){
		if(!args){args={};}
		if(action in this.actions_internes){
			this.actions_internes[action](args);
		}
		else if(action in this.actions){
			this.actions[action](args);
		}
		else{
			// console.log("Attention, action '"+action+"' non reconnue");
		}
	}
	
	this.setActionsInternes=function(){
		var that=this;
		this.actions_internes={
			pause : function(args){
				if('dt' in args){var dt=parseInt(args['dt']);}
				else{var dt=1000;}
				that.pause=true;
				setTimeout(function(){
					that.pause=false;
					//that.afficher_message();
				},dt);
			}
		};
	}
	
	// constructor(options){
	UTIL.setOptions(this, Message.CONST.options_defaut);
	
	this.initDOM();
	
	this.setMessage(options);
	
	this.setActionsInternes();
	// }
	
}
Message.CONST={
	options_defaut:{
		container : null,
		defile:true,
		
		dt : 20,
		paragrapheXML:null,
		pause:true,
		duree_transition:0,// 0 pour transition par click,
		fini:false,
		actions:{},
		to:-1,
		txt:'',
		n:0
	},
	re : {
		balise : /^<[^<>]+>/,
	}
}

Message.JS_Fonc={//that représente l'instance de Message, passée en argument
	click_mode_defiler:function(that, e){
		if(e.target.tagName.toLowerCase()!='p'){return;}//évite le click du choix précédent
		// if(that.pause){return;}
		that.stop_defiler();
		if(e.target!=that.containerDOM){return;}
		that.stop();
		that.defile=false;//mode decale
		var temp=that.containerDOM.scrollTop;//texte écrit en entier et repositionnement du scroll.
		that.containerDOM.innerHTML=that.paragrapheXML.innerHTML;
		that.containerDOM.scrollTop=temp;
		
		//modif...
		var icone = document.createElement("div");
		that.boxDOM.appendChild(icone);
		icone.className="arrow_decale fade";
		
		that.boxDOM.onclick=function(){return that.decaler(that);}
	},
	click_mode:function(that){
		// that.stop_defiler();
		// that.stop();
		// that.defile=false;//mode decale
		
		//modif...
		var icone = document.createElement("div");
		that.boxDOM.appendChild(icone);
		icone.className="arrow_decale fade";
		
		that.boxDOM.onclick=function(){that.pause=false;that.transition();}
	},
	//liXML est l'élément XML (li) représenté par l'élément DOM sur lequel on vient de cliquer
	click_choix:function(that, liXML){
		if(liXML.getAttribute('type')=='once'){//ligne de choix consommée
			liXML.setAttribute('ignore', 'true');
		}
		if(liXML.getAttribute('type')=='quit'){//on quitte la conversation
			var ul=PROC.remonte(liXML, this.XML, 'ul');
			if(ul){
				ul.setAttribute('type', 'once');//tout sauf 'stay'
				that.paragrapheXML=ul;
			}
		}
		else{//tous les cas sauf quit : on entre dans le dialogue
			that.paragrapheXML=PROC.next(null, liXML, 'title');
			if(!that.paragrapheXML){
				throw("'title' manquant dans choix de dialogue ");
			}
			
			// that.paragrapheXML=liXML.firstElementChild;
			// if(that.paragrapheXML && that.paragrapheXML.tagName.toLowerCase()!='title'){
				// that.paragrapheXML=PROC.next(that.paragrapheXML, that.XML, 'title');
			// }
			// if(!that.paragrapheXML){
				// throw("'title' manquant dans choix de dialogue ");
			// }
		}
		
		liXML.setAttribute('visited', 'true');
		
		
		that.boxDOM.className='message_box';
		UTIL.empty(that.containerDOM);
		that.defile=Message.CONST.options_defaut.defile;;//??
		that.pause=false;//??
		
		for(var i=0;i<liXML.parentElement.children;i++){
			// if(liXML.parent.children.onclick){
			liXML.parent.children.removeAttribute('onclick');
			// }
		}
		
		that.transition();
	}
	
}
