/////////////////////////////////////
///           Perso              ///
////////////////////////////////////
// class Perso{
Perso=function(options){
	this.setPerso=function(options){
		options=UTIL.options2json(options);
		if(typeof options=="string" || !options){
			throw("Element DOM non trouvé pour créer instance de Perso");
		}
		else if('XML' in options){
			this.XML=options.XML;
		}
		else if('perso' in options){
			this.XML=options.perso;
		}
		else{
			throw("Pas d'élément 'XML' permettant d'instancier le Perso");
		}
		if(typeof this.XML=='string'){
			console.log("Warning, debug ici");
			this.XML=UTIL.findOrCreate(this.XML, this.rootDOM);
		}
		UTIL.setOptions(this, options, Perso.CONST.options_defaut);
		this.initialisation();
	}
	
	this.initialisation=function(){
		this.containerDOM.style.opacity=0;	
		this.fini=false;
	}
	
	this.initDOM=function(){
		var that=this;		
		this.rootDOM = UTIL.findOrCreate('#theatre');
		this.containerDOM=document.createElement("div");
		// this.containerDOM.className=this.constructor.name;//Perso ou agentDialogue
		this.containerDOM.className='Perso';//Perso ou agentDialogue
		this.containerDOM.style.opacity=0;
		this.rootDOM.appendChild(this.containerDOM);
	}
	
	//Accepte un id ou une requete DOM indiquant la position du conteneur (#id par exemple)
	this.setContainerDOM=function(container){
		if(!container){throw("Conteneur DOM nécessaire pour instancier un personnage");}
		if(!UTIL.isElement(container)){
			if(typeof container=='string'){
				this.containerDOM=document.querySelector(container);
				if(!this.containerDOM){throw("Element non trouvé : " + container);}
			}
			else{
				throw("Conteneur nécessaire pour instancier le personnage");
			}
		}
		else{
			this.containerDOM=container;
		}
	}
	
	this.setSprites=function(imageURL, w, h, param_sprites, grille){
		this.elements=UTIL.keys(param_sprites);
		this.sprites={};
		var i=-1;
		for(var el in param_sprites){
			i++;
			if(typeof el!='string'){throw("Chaque élement du Perso doit être donné sous forme d'un Str" + i);}
			if(!(el in param_sprites)){throw("Element " + el + "manquant dans param_sprites");}
			//création canvas dans le dom et paramétrages
			var node = document.createElement("canvas");
			this.containerDOM.appendChild(node);
			node.width = w;
			node.height = h;
			node.style.zIndex=this.elements.length-i;
			

			
			this.sprites[el] = new Sprite({
			name:el,
			context: node.getContext("2d"),
			width: w,
			height: h,
			imageURL : imageURL,
			grille :grille,
			idFrames:param_sprites[el].idFrames,
			sequence:[],
			n:0,
			//ticksPerFrame:20 ,
			//ticksBetweenLoops:100,
			loop:false,
			 freeze:true
			});
			
			 UTIL.setOptions(this.sprites[el], param_sprites[el]);
			 this.sprites[el].initialisation();
		}
		this.width_sprites=w;
		this.height_sprites=h;
		this.ratio=h/w;
		this.grille=grille;
		this.param_sprites=param_sprites;// utile ?
	}
	
	this.setDimensions=function(w, h){
		this.setWidth(w);
		this.setHeight(h);
	}
	
	this.setWidth=function(w){
		var temp=w.toString().match(/[^0-9]+$/);
		var unit=!temp ? 'px' : temp[0];
		var temp=w.toString().match(/^[0-9]+/);
		if(!temp){throw("Largeur non reconnue");}
		w=temp[0];
		
		if(this.keep_ratio){
			var h=parseInt(w)*this.ratio;
			h=h.toString();
			this.height=h+unit;
			this.containerDOM.style.height=h+unit;
		}
		this.width=w+unit;
		this.containerDOM.style.width=w+unit;
	}

	this.setHeight=function(h){
		var temp=h.toString().match(/[^0-9]+$/);
		var unit=!temp ? 'px' : temp[0];
		var temp=h.toString().match(/^[0-9]+/);
		if(!temp){throw("Largeur non reconnue");}
		h=temp[0];
		
		if(this.keep_ratio){
			var w=parseInt(w)*this.ratio;
			w=w.toString();
			this.width=w+unit;
			this.containerDOM.style.width=w+unit;
		}
		this.height=h+unit;
		this.containerDOM.style.heighy=h+unit;
	}
	
	this.setLeft=function(l){
		this.left=l;
		this.containerDOM.style.left=l;
	}

	this.setTop=function(t){
		this.top=t;
		this.containerDOM.style.top=t;
	}
		
	this.addDependances=function(dependances){
		if(!this.dependances){this.dependances={};}
		for(var el0 in dependances){
			if(!(el0 in this.sprites)){throw("Mauvaise clé 0 " + el0 + " pour les dependances Perso");}
			for(var k in dependances[el0]){
				for(var el1 in dependances[el0][k]){
					if(!(el1 in this.sprites)){throw("Mauvaise clé 1 " + el1 + " pour les dependances Perso");}
					for(var att in dependances[el0][k][el1]){
						if(!(att in Sprite.CONST.options_defaut)){throw("Mauvais attribut Sprite " + att + " pour les dependances Perso");}
					}
				}
			}
			this.dependances[el0]=dependances[el0];
		}
	}
	
	this.addRaccourcis=function(raccourcis){
		if(!raccourcis){var raccourcis={};}
		var that=this;
		if(!this.raccourcis){this.raccourcis={};}
		for(var rac in raccourcis){
			for(var el1 in raccourcis[rac]){
				if(el1=='options'){continue;}//la clé "options" est réservé pour la fonction execute
				if(!(el1 in this.sprites)){throw("Mauvaise clé 1 " + el1 + ' ' + rac + " pour les raccourcis Perso");}
				for(var att in raccourcis[rac][el1]){
					if(!(att in Sprite.CONST.options_defaut)){throw("Mauvais attribut Sprite " + att + " pour les raccourcis Perso");}
				}
			}
		this.raccourcis[rac]=raccourcis[rac];
		}
	}
	
	//affiche, lance les Sprites
	this.start=function(){
		if(!this.pause){return;}
		this.pause=false;
		this.fini=false;
		this.afficher();
		this.startSprites();
		this.loop();
	}
	
	//Stoppe les animations
	this.stop=function(){
		this.pause=true;
	}
	
	//Stoppe les animations, Arrête les update et cache les Sprites
	this.fin=function(){
		this.stop();
		this.fini=true;
		this.cacher();
	}
	
	this.afficher=function(){
		// this.containerDOM.style.display="block";
		this.startSprites();
		UTIL.addClass(this.containerDOM, this.transition);
		this.containerDOM.style.opacity=1;
	}
	
	this.cacher=function(){
		var that=this;
		
		switch(this.transition){
			case 'fade':
				this.containerDOM.style.opacity=0;
				// this.to=setTimeout(function(){that.fini=true;},100);
			break;
			case 'wait':
				this.containerDOM.style.opacity=0;
				// this.to=setTimeout(function(){that.fini=true;},100);
			break;
			case 'stay':
				this.fini=true;
				//reste là figé
			break;
			default:
				this.containerDOM.style.opacity=0;
			break;
		}
	}
	
	this.startSprites=function(){
		for(var i=0;i<this.elements.length;i++){
			this.sprites[this.elements[i]].start();
		}
	}
	
	this.stopSprites=function(){
		for(var i=0;i<this.elements.length;i++){
			this.sprites[this.elements[i]].stop();
		}
	}
	
	this.loop=function(){
		if(this.pause){return;}
		var that=this;
		window.requestAnimationFrame(function(){that.loop()});
		
		this.updateDependancesSprites();// à mettre ailleurs (?), quand on change la tête par exemple
		
	}

	this.updateDependancesSprites=function(){//tests plus nécessaire depuis les setters
		var dep=this.dependances;
		for(var el_s in dep){
			if(el_s in this.sprites){
				if(this.sprites[el_s].n in dep[el_s]){
					for(var el_t in dep[el_s][this.sprites[el_s].n]){
						if(el_t in this.sprites){
							for(var att in dep[el_s][this.sprites[el_s].n][el_t]){
								if(att in this.sprites[el_t]){
									this.sprites[el_t][att] = dep[el_s][this.sprites[el_s].n][el_t][att];
									this.sprites[el_t].render();
								}
							}
						}
					}
				}
			}
		}
	}
	
	this.execute=function(k){//tests plus nécessaires depuis les setters
		var applique=false;
		var t_wait=0;
		var that=this;
		if(k in this.raccourcis){
			// console.log("Affiche " + k);
			applique=true;
			if('options' in this.raccourcis[k]){
				if(("transition" in this.raccourcis[k].options) && (this.raccourcis[k].options.transition=='fade') ){
					t_wait=100;
					this.cacher();
					setTimeout(function(){that.afficher();},100);
				}
			}
			setTimeout(
				function(){
					for(var el in that.raccourcis[k]){
						if(el in that.sprites  && el!='options'){//options est le seul terme réservé dans les raccourcis
							// console.log(that.sprites[el]);
							UTIL.setOptions(that.sprites[el],that.raccourcis[k][el]);
							//appliquer la transition ?? peut être dans l'initialisation plutot...
							that.sprites[el].initialisation();
							
						}
					}
				}
				,t_wait
			);
			
		}
		return applique;
	}
	// constructor(options){
	if(UTIL.isElement(options)){options=UTIL.node2json(options);}
	UTIL.setOptions(this, Perso.CONST.options_defaut);
	UTIL.setOptions(this, options, Perso.CONST.options_defaut);
	this.initDOM();
	this.setPerso(options);
	
	//ne seront pas modifiés après instanciation :
	this.setSprites(options.imageURL, options.width_sprites, options.height_sprites, options.param_sprites, options.grille);
	//là ça devient bizarre.... ça n'a pas trop de sens : pixels, poucents ?
	this.setDimensions(options.width, options.height, options.width_sprites, options.height_sprites);
	this.actions = options.actions||{};
	this.addDependances(options.dependances);
	this.addRaccourcis(options.raccourcis);
	this.pause=true;
	// }
}	
Perso.CONST={
	options_defaut:{
		name:'noname',
		keep_ratio:true,
		transition : 'fade'
	}
}	